fl

{
LED driver (PCA9624)
      
PropForth 5.5
2015/04/20 20:26:28

  PCA9624     Propeller
     A0  ---  GND
     A1  ---  GND
     A2  ---  GND
     A3  ---  GND
     A4  ---  3.3V
     A5  ---  GND
     A6  ---  GND
     OE  ---  GND
     
     LED0 -- -LED+ -- 510ohm -- 3.3V
     LED1 -- -LED+ -- 510ohm -- 3.3V
     LED2 -- -LED+ -- 510ohm -- 3.3V
     LED3 -- -LED+ -- 510ohm -- 3.3V
     LED4 -- -LED+ -- 510ohm -- 3.3V
     LED5 -- -LED+ -- 510ohm -- 3.3V
     LED6 -- -LED+ -- 510ohm -- 3.3V
     LED7 -- -LED+ -- 510ohm -- 3.3V
}

\ =========================================================================== 
\ Constants 
\ =========================================================================== 
\ Slave addres h10 for PCA9624 
h20 wconstant PCA9624
\ Software Reset 3
6 wconstant PCA9624_rst
\ All LED Call Address h70
hE0 wconstant PCA9624_call
\ Software Reset call
6 wconstant SWRST

\ register
0 wconstant mode1
1 wconstant mode2
2 wconstant PWM0
3 wconstant PWM1
4 wconstant PWM2
5 wconstant PWM3
6 wconstant PWM4
7 wconstant PWM5
8 wconstant PWM6
9 wconstant PWM7
hA wconstant GRPPWM
hB wconstant GRPFREQ
hC wconstant LEDOUT0
hD wconstant LEDOUT1
hE wconstant SUBADR1
hF wconstant SUBADR2
h10 wconstant SUBADR3
h11 wconstant ALLCALLADR

\ Auto Increment Code
0 wconstant no_inc
h80 wconstant all_inc          \ (register:0 - h11)
hA0 wconstant bright_inc       \ (register:2 - h11)
hC0 wconstant group_inc        \ (register:hA - hB)
hE0 wconstant brt_grp_inc      \ (register:2 - hB)
 
\ =========================================================================== 
\ Main 
\ =========================================================================== 

\ Software Reset
\ After send hA5 and h5A following SWRST, PCA9624 is resetting.
\ ( -- )
: SoftReset
\ Start I2C 
_eestart
\ Write SWRST, then receive Acknowledge-bit(ACK:Lo  NACK:Hi) 
SWRST _eewrite                      
hA5 _eewrite or
h5A _eewrite or
\ Stop I2C
_eestop
err? 
;

\ allocate string
\ ( -- )
: s, parsenw dup C@ 1+ bounds dup rot2 do C@++ c, loop drop ;

wvariable string -2 allot 
s, MODE1 s, MODE2 
s, PWM0 s, PWM1 s, PWM2 s, PWM3 s, PWM4 s, PWM5 s, PWM6 s, PWM7 
s, GRPPWM s, GRPFREQ
s, LEDOUT0 s, LEDOUT1
s, SUBADR1 s, SUBADR2 s, SUBADR3
s, ALLCALLADR

\ Display allocated string above
\ ( n1 n2 -- )  n1:string index  n2:string's top address
: dispStr 
swap dup 0 <> 
if  
     0 do
          dup C@ + 1+
     loop     
else
     drop     
then 
.cstr 
;

\ TAB
\ ( -- )
: tab 9 emit ;
: 2tab tab tab ;

\ Set auto increment
\ ( -- )
: AutoIncr h80 or ;

\ Display all registers from mode1 to ALLCALLADR
\ ( -- )
: rd_allreg
hex
d18 0 do
     mode1 AutoIncr i + PCA9624 i2c_rd err?
     i string dispStr ." :" 
     i d11 < if 2tab else tab then
     ." h" . cr   
loop
decimal
cr
;

\ Display all registers from ALLCALLADR to mode1
\ ( -- )
: rd_allreg_rev
hex
d18 mode1 AutoIncr PCA9624 i2c_rd_multi err?
d18 0 do
     d17 i - string dispStr ." :" 
     i 7 < if tab else 2tab then
     ." h" . cr   
loop
decimal
cr
;

\ Drive 8 LED elemets from pwm 0% to pwm 99.6%
\ ( -- )
: demo
\ Set Normal[b4]
1 mode1 PCA9624 i2c_wr err?   
\ Set LED3,2,1,0:PWM and LED7,6,5,4:PWM
\ LDRx=10
hAA hAA 2 LEDOUT0 AutoIncr PCA9624 i2c_wr_multi err?  
            
begin
     d256 0 do
          i i i i i i i i 
          8 PWM0 AutoIncr PCA9624 i2c_wr_multi err? 
          d10 delms
     loop                    
     fkey? swap drop         
until                     
SoftReset                        
;

